/* 
 * Test class to practice mouse movement by drawing a circle where the cursor is. 
 * 
 * Jacob Coon
 * 12/2/14
 */
 
import java.awt.*; 
import javax.swing.*; 
import java.awt.event.*; 
import java.awt.image.*; 
 
public class Ball
{
    int ballX = 250;
    int ballY = 250;
    int changeInX = findRandom(-5,5);
    int changeInY = findRandom(-5,5);
    Score theScore;
    public void draw(Graphics oG)
    {
        oG.setColor(findRandomColor());
        oG.fillOval(ballX,ballY,20,20);
    }
 
    public void resetBall()
    {
        if (ballX >= 500 )
        {
            ballX = 250;
            ballY = 250;
            changeInX = findRandom(-5,5);
            changeInY = findRandom(-5,5);
            theScore.p1Score++;
        }
        if (ballX <= 0)
        {
            ballX = 250;
            ballY = 250;
            changeInX = findRandom(-5,5);
            changeInY = findRandom(-5,5);
            theScore.p2Score++;
        }
        /*
         * I created the resetBall() method so that it could determined what would happen to the 
         * ball IN Ball and then I could actually call the command in Pong
         */
    }
 
    public void move()
    {
        ballX=ballX+changeInX;
        ballY=ballY+changeInY;
        if (ballY >= 500 || ballY<=0)
        {
            if (changeInY<0)
            {
                changeInY = changeInY - 2;
                changeInY = -changeInY;
            }
            else if (changeInY>0)
            {
                changeInY = changeInY + 2;
                changeInY = -changeInY;
            }
            //the +/- 2 increases the speed of the ball
        }
        
    }
 
    public boolean collide(Paddle thePaddle)
    {
        //the dimensions of my paddles are 15x75
        if (ballX+20>=thePaddle.x && ballX<=thePaddle.x+15 &&
        ballY+20 >= thePaddle.y && ballY <= thePaddle.y+75)
        {
            if (changeInX<0)
            {
                changeInX = changeInX - 2;
                changeInX = -changeInX;
            }
            else if (changeInX>0)
            {
                changeInX = changeInX + 2;
                changeInX = -changeInX;
            }
            //same here for the speed
            return true;
        }
        return false;
    }
 
    public int findRandom (int start, int end)
    {
        int multiplier = end-start+1;
        int random = (int) (Math.random()*multiplier)+start;
        return random;
    }
 
    public Color findRandomColor ()
    {
        int red= (int)(256 * Math.random());
        int green= (int)(256 * Math.random());
        int blue= (int)(256 * Math.random());
        Color randomColor=new Color(red,green,blue);
        return randomColor;
    } 
 
}